searchNodes=[{"doc":"EctoRange is a tiny library that provides Ecto custom types for all Postgres Range types . The main design goal of EctoRange is to be easy to use with native Elixir types, while providing the full flexibility of Postgres Range types inside of Ecto. Postgres type Ecto.Type int4range EctoRange.Int4 int8range EctoRange.Int8 numrange EctoRange.Num tsrange EctoRange.Timestamp tstzrange EctoRange.TimestampTZ daterange EctoRange.Date Usage EctoRange provides custom types, and can be used like any other Ecto type. defmodule MyApp.Repo.Migrations.AddRange do use Ecto.Migration def change do create table ( :my_table ) do add :name , :string add :range , :daterange end end end defmodule MyApp.Table do use Ecto.Schema import Ecto.Changeset schema &quot;my_table&quot; do field ( :name , :string ) field ( :range , EctoRange.Date ) end def changeset ( table , params ) do table |&gt; cast ( params , [ :name , :range ] ) |&gt; validate_required ( [ :name , :range ] ) end end iex&gt; alias MyApp.Table iex&gt; range = Date . range ( ~D[1989-09-22] , ~D[2021-03-01] ) iex&gt; cs = Table . changeset ( % Table { } , %{ name : &quot;table&quot; , range : range } } iex&gt; cs . changes % Ecto.Changeset { changes : %{ range : % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-01] , lower_inclusive : true , upper_inclusive : true } , name : &quot;name&quot; } , data : % MyApp.Table { id : nil , name : nil , range : nil } , params : %{ &quot;range&quot; =&gt; Date . range ( ~D[1989-09-22] , ~D[2021-03-01] ) , &quot;name&quot; =&gt; &quot;name&quot; } , valid? : true } Installation If available in Hex , the package can be installed by adding ectorange to your list of dependencies in mix.exs : def deps do [ { :ecto_range , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/ectorange . Alternative libraries If you're unhappy with the feature set EctoRange , there are some alternative libraries that provide similar functionality ecto_date_time_range pg_ranges","ref":"EctoRange.html","title":"EctoRange","type":"module"},{"doc":"A custom type for working with the Postgres daterange type. iex&gt; range = Date . range ( ~D[1989-09-22] , ~D[2021-03-01] ) iex&gt; cs = TestApp.Table . changeset ( % TestApp.Table { name : &quot;EctoRange.Date&quot; } , %{ range : range } ) iex&gt; cs . changes %{ range : % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-01] , lower_inclusive : true , upper_inclusive : true } } Casting EctoRange.Date provides a couple of conveniences when casting data. All valid data will be cast into a Postgrex.Range.t/0 struct. When supplied to an Ecto.Changeset, the following types are valid Date.Range.t/0 will be treated as an inclusive range {t:date() | t:String.t/0, t:date() | t:String.t/0} can be used to express unbounded ranges, where nil represents an unbounded endpoint Postgrex.Range.t/0 will be treated as a valid range representation Loading All data loaded from the database will be normalized into an inclusive range to align with the semantics of Date.Range.t()","ref":"EctoRange.Date.html","title":"EctoRange.Date","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoRange.Date.html#embed_as/1","title":"EctoRange.Date.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoRange.Date.html#equal?/2","title":"EctoRange.Date.equal?/2","type":"function"},{"doc":"Converts a Postgrex.Range.t() into a normalized form. For bounded ranges, it will make the lower and upper bounds inclusive to align with the semantics of Date.Range.t() iex&gt; range = % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-02] , lower_inclusive : true , upper_inclusive : false } iex&gt; EctoRange.Date . normalize_range ( range ) % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-01] , lower_inclusive : true , upper_inclusive : true } iex&gt; range = % Postgrex.Range { lower : ~D[1989-09-21] , upper : ~D[2021-03-01] , lower_inclusive : false , upper_inclusive : true } iex&gt; EctoRange.Date . normalize_range ( range ) % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-01] , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Date.html#normalize_range/1","title":"EctoRange.Date.normalize_range/1","type":"function"},{"doc":"Converts valid Date.Range.t() or Date.t() tuples into a Postgrex.Range.t() iex&gt; EctoRange.Date . to_postgrex_range ( Date . range ( ~D[1989-09-22] , ~D[2021-03-01] ) ) % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-01] , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Date.html#to_postgrex_range/1","title":"EctoRange.Date.to_postgrex_range/1","type":"function"},{"doc":"","ref":"EctoRange.Date.html#t:date/0","title":"EctoRange.Date.date/0","type":"type"},{"doc":"A Postgres range of int4 integers. Equivalent to int4range .","ref":"EctoRange.Int4.html","title":"EctoRange.Int4","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoRange.Int4.html#embed_as/1","title":"EctoRange.Int4.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoRange.Int4.html#equal?/2","title":"EctoRange.Int4.equal?/2","type":"function"},{"doc":"Converts a Postgrex.Range.t() into a normalized form. For bounded ranges, it will make the lower and upper bounds inclusive. Examples iex&gt; range = % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : true , upper_inclusive : false } iex&gt; EctoRange.Int4 . normalize_range ( range ) % Postgrex.Range { lower : 1 , upper : 2 , lower_inclusive : true , upper_inclusive : true } iex&gt; range = % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : false , upper_inclusive : true } iex&gt; EctoRange.Int4 . normalize_range ( range ) % Postgrex.Range { lower : 2 , upper : 3 , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Int4.html#normalize_range/1","title":"EctoRange.Int4.normalize_range/1","type":"function"},{"doc":"Checks and converts a Postgrex.Range or tuple into a Postgrex.Range.t() Examples iex&gt; EctoRange.Int4 . to_postgrex_range ( { 1 , 3 } ) % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Int4.html#to_postgrex_range/1","title":"EctoRange.Int4.to_postgrex_range/1","type":"function"},{"doc":"A Postgres range of int8 integers. Equivalent to int8range . Allows bigint values.","ref":"EctoRange.Int8.html","title":"EctoRange.Int8","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoRange.Int8.html#embed_as/1","title":"EctoRange.Int8.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoRange.Int8.html#equal?/2","title":"EctoRange.Int8.equal?/2","type":"function"},{"doc":"Converts a Postgrex.Range.t() into a normalized form. For bounded ranges, it will make the lower and upper bounds inclusive. Examples iex&gt; range = % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : true , upper_inclusive : false } iex&gt; EctoRange.Int8 . normalize_range ( range ) % Postgrex.Range { lower : 1 , upper : 2 , lower_inclusive : true , upper_inclusive : true } iex&gt; range = % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : false , upper_inclusive : true } iex&gt; EctoRange.Int8 . normalize_range ( range ) % Postgrex.Range { lower : 2 , upper : 3 , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Int8.html#normalize_range/1","title":"EctoRange.Int8.normalize_range/1","type":"function"},{"doc":"Checks and converts a Postgrex.Range or tuple into a Postgrex.Range.t() Examples iex&gt; EctoRange.Int8 . to_postgrex_range ( { 1 , 3 } ) % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Int8.html#to_postgrex_range/1","title":"EctoRange.Int8.to_postgrex_range/1","type":"function"},{"doc":"A Postgres range of numeric values. Equivalent to numrange . Allows numeric values of all precisions. Returns Decimal structs when loading from the database. Watch out: Not defining the precision of your values, might cause compatibility problems with other systems in the future.","ref":"EctoRange.Num.html","title":"EctoRange.Num","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoRange.Num.html#embed_as/1","title":"EctoRange.Num.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoRange.Num.html#equal?/2","title":"EctoRange.Num.equal?/2","type":"function"},{"doc":"Converts a Postgrex.Range.t() into a normalized form. For bounded ranges, it will make the lower and upper bounds inclusive. All upper and lower bounds are converted to %Decimal{} structs, if necessary. Examples iex&gt; range = % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : true , upper_inclusive : false } iex&gt; EctoRange.Num . normalize_range ( range ) % Postgrex.Range { lower : % Decimal { coef : 1 } , upper : % Decimal { coef : 2999999999 , exp : - 9 } , lower_inclusive : true , upper_inclusive : true } iex&gt; range = % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : false , upper_inclusive : true } iex&gt; EctoRange.Num . normalize_range ( range ) % Postgrex.Range { lower : % Decimal { coef : 1000000001 , exp : - 9 } , upper : % Decimal { coef : 3 } , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Num.html#normalize_range/1","title":"EctoRange.Num.normalize_range/1","type":"function"},{"doc":"Checks and converts a Postgrex.Range or tuple into a Postgrex.Range.t() Examples iex&gt; EctoRange.Date . to_postgrex_range ( { 1 , 3 } ) % Postgrex.Range { lower : 1 , upper : 3 , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Num.html#to_postgrex_range/1","title":"EctoRange.Num.to_postgrex_range/1","type":"function"},{"doc":"A custom type for working with the Postgres tsrange type. iex&gt; range = { ~N[2020-10-31 09:30:00] , ~N[2020-11-02 10:00:00] } iex&gt; cs = TestApp.Table . changeset ( % TestApp.Table { name : &quot;EctoRange.Timestamp&quot; } , %{ tsrange : range } ) iex&gt; cs . changes %{ tsrange : % Postgrex.Range { lower : ~N[2020-10-31 09:30:00] , upper : ~N[2020-11-02 10:00:00] , lower_inclusive : true , upper_inclusive : true } } tsrange in Postgres is a continuous range, and does not have any equivalent Elixir struct. Casting EctoRange.Timestamp provides a couple of conveniences when casting data. All valid data will be cast into a Postgrex.Range.t/0 struct. When supplied to an Ecto.Changeset, the following types are valid {t:timestamp() | t:String.t/0, t:timestamp() | t:String.t/0} can be used to express unbounded ranges, where nil represents an unbounded endpoint Postgrex.Range.t/0 will be treated as a valid range representation Loading All data loaded from the database will be normalized into an inclusive range to align with the semantics of Date.Range.t()","ref":"EctoRange.Timestamp.html","title":"EctoRange.Timestamp","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoRange.Timestamp.html#embed_as/1","title":"EctoRange.Timestamp.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoRange.Timestamp.html#equal?/2","title":"EctoRange.Timestamp.equal?/2","type":"function"},{"doc":"Converts a Postgrex.Range.t() into a normalized form. For bounded ranges, it will make the lower and upper bounds inclusive to align with the semantics of Date.Range.t() iex&gt; range = % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-02] , lower_inclusive : true , upper_inclusive : false } iex&gt; EctoRange.Date . normalize_range ( range ) % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-01] , lower_inclusive : true , upper_inclusive : true } iex&gt; range = % Postgrex.Range { lower : ~D[1989-09-21] , upper : ~D[2021-03-01] , lower_inclusive : false , upper_inclusive : true } iex&gt; EctoRange.Date . normalize_range ( range ) % Postgrex.Range { lower : ~D[1989-09-22] , upper : ~D[2021-03-01] , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Timestamp.html#normalize_range/1","title":"EctoRange.Timestamp.normalize_range/1","type":"function"},{"doc":"Converts valid NaiveDateTime.t() tuples into a Postgrex.Range.t() iex&gt; EctoRange.Date . to_postgrex_range ( { ~N[2021-03-01 08:30:00] , ~N[2023-03-30 10:30:00] } ) % Postgrex.Range { lower : ~N[2021-03-01 08:30:00] , upper : ~N[2023-03-30 10:30:00] , lower_inclusive : true , upper_inclusive : true }","ref":"EctoRange.Timestamp.html#to_postgrex_range/1","title":"EctoRange.Timestamp.to_postgrex_range/1","type":"function"},{"doc":"","ref":"EctoRange.Timestamp.html#t:timestamp/0","title":"EctoRange.Timestamp.timestamp/0","type":"type"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Added Support for tsrange via EctoRange.Timestamp Example of EctoRange.Date in the README","ref":"changelog.html#0-2-0","title":"Changelog - [0.2.0]","type":"extras"},{"doc":"Initial release","ref":"changelog.html#0-1-0-2023-03-25","title":"Changelog - 0.1.0 - 2023-03-25","type":"extras"}]